function retVal =  AnalyzeIGT(dType, wildcard, dirName, numBlocks, dir2, wildcard2, newFileName, currFileName, analysisStep)
    switch lower(dType)
        %Give block-based descriptive stats for behavioral data
        case 'beh'
            
            if (nargin < 4)
               numBlocks = 5;
            end
            
            retVal = AnalyzeBehavior(wildcard, dirName, numBlocks);
             
        %Temporally aligns EDA data with Behavioral data, separates data
        %into 3 phases (anticipatory, deck, rew/loss), and uses the ledalab
        %scripts to analyze the SCR data.
        case 'eda'
            if(exist('analysisStep','var'))
                ProcessEDA(wildcard, dirName, numBlocks, wildcard2, dir2, analysisStep);
            else
                ProcessEDA(wildcard, dirName, numBlocks, wildcard2, dir2);
            end
        %Summarizes EDA file output from 'eda' step
        case 'summeda'
            SummarizeEDA(dirName, '..\subjs', newFileName, currFileName, numBlocks);
    end
end



