function [wPtr, wRect] = InitScreen(simulation)
    AssertOpenGL;
    v = Screen('Preference', 'verbosity', 3);
    screenID = max(Screen('Screens'));
    screenSize = Screen('Resolution', screenID);
    HideCursor();
    if( isempty(simulation) || ~simulation )
        [wPtr, wRect] = Screen('OpenWindow', screenID, 0, [], [], 2);
    else
        [wPtr, wRect] = Screen('OpenWindow', screenID, 0, [100 80 1580 750], [], 2);
    end
    white = WhiteIndex(wPtr); % pixel value for white
    black = BlackIndex(wPtr); % pixel value for black
    Screen('BlendFunction', wPtr, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    gray = (white + black) / 2;
    Screen(wPtr, 'FillRect', white);
    Screen(wPtr, 'Flip');
end