function texture = MarkSelectedDeck(wPtr, imageDir, selectedDeck, isRed, waitFlag, myPort, modelCommID, deckColors, dPLength)
    %disp('In MarkSelectedDeck');
    if(exist('modelCommID', 'var') && ~isempty(modelCommID) && modelCommID ~= -1)
        TimeMsg(modelCommID);
    end
    screenSize = Screen('Resolution', wPtr);
    if(exist('modelCommID', 'var') && ~isempty(modelCommID) && modelCommID ~= -1)
        wSpace = 1680 / 1.2;
        hSpace = 1050;
    else
        wSpace = (screenSize.width/1.2);
        hSpace = screenSize.height;
    end
    deckSize = size(deckColors, 2);
    posX = (screenSize.width - wSpace)/2;
    posY = ((hSpace / 2) - 245);
    cardWidth = 200;
    cardHeight = 278;
    
    xShift = (wSpace - deckSize*200)/(deckSize - 1);
     
%     deckA = [posX, posY, posX + cardWidth, posY + cardHeight];
%     deckB = deckA + [posX + cardWidth, 0, posX + cardWidth, 0];
%     deckC = deckB + [posX + cardWidth, 0, posX + cardWidth, 0];
%     deckD = deckC + [posX + cardWidth, 0, posX + cardWidth, 0];
    
    deckParam = [posX, posY, cardWidth, cardHeight];
    
    deckPos = [posX, posY, posX + cardWidth, posY + cardHeight];
    
    for i = 1:(deckSize)
        if( i ~= 1 )
            deckPos = deckPos + [xShift + cardWidth, 0, xShift + cardWidth, 0];
        end
        
        switch i
            case 1
                keyGlyphTest = strcat(num2str(i), '!');
            case 2
                keyGlyphTest = strcat(num2str(i), '@');
            case 3
                keyGlyphTest = strcat(num2str(i), '#');
            case 4
                keyGlyphTest = strcat(num2str(i), '$');
            case 5
                keyGlyphTest = strcat(num2str(i), '%');
            case 6
                keyGlyphTest = strcat(num2str(i), '^');
            case 7
                keyGlyphTest = strcat(num2str(i), '&');
            case 8
                keyGlyphTest = strcat(num2str(i), '*');
            case 9
                keyGlyphTest = strcat(num2str(i), '(');
        end
            
        %update decks struct for card selected (& set selectedDeck
        % variable
        if( strcmpi(selectedDeck, char(i+96)) || ...
             strcmpi(selectedDeck, keyGlyphTest) || ...
             strcmpi(selectedDeck, num2str(i)) )
         break
        end
    end

%     if( strcmpi(selectedDeck, 'a') || strcmpi(selectedDeck, '1') || ...
%             strcmpi(selectedDeck, '1!') )
%         
%         deckPos = deckA;
%         deckVal = 'a';
% 
%     elseif( strcmpi(selectedDeck, 'b') || strcmpi(selectedDeck, '2') || ...
%             strcmpi(selectedDeck, '2@') )
%         
%         deckPos = deckB;
%         deckVal = 'b';
% 
%     elseif( strcmpi(selectedDeck, 'c') || strcmpi(selectedDeck, '3') || ...
%             strcmpi(selectedDeck, '3#') )
%         
%         deckPos = deckC;
%         deckVal = 'c';
% 
%     elseif( strcmpi(selectedDeck, 'd') || strcmpi(selectedDeck, '4') || ...
%             strcmpi(selectedDeck, '4$') )
%         
%         deckPos = deckD;
%         deckVal = 'd';
%         
%     end
    
    if( ~isRed )
        img = imread(fullfile(imageDir, 'blackBack.jpeg'), 'JPG');
    else
        img = imread(fullfile(imageDir, 'redBack.jpeg'), 'JPG');
    end


    texture = Screen('MakeTexture', wPtr, double(img));
    Screen('DrawTextures', wPtr, texture, [], deckPos');
    Screen('Flip', wPtr, [], 1);
    
    if(exist('modelCommID', 'var') && ~isempty(modelCommID) && modelCommID ~= -1)
        modelMsg = pnet(modelCommID, 'read', 'noblock');
        while(isempty(strfind(modelMsg, 'set-mp-time')))
           if(~isempty(modelMsg))
               SyncMsg(modelCommID);
           end
           modelMsg = pnet(modelCommID, 'read', 'noblock');
        end
    end
    
    if( myPort == -1 && exist('modelCommID', 'var') && ~isempty(modelCommID) && modelCommID ~= -1 )
        SyncMsg(modelCommID);
        startTime = ConvertJSONTime(modelMsg);
    end
    
    
    
    if( myPort ~= -1 && myPort)
        %Write to eye-tracker so we know this data should be associated
        %with the MarkSelected Deck Function 251
        IOPort('Write', myPort, uint8(251));
    elseif( exist('modelCommID', 'var') && ~isempty(modelCommID) && modelCommID ~= -1 )
        if( isRed )
            if(~isempty(pnet(modelCommID, 'read', 'noblock', 'view')))
                pnet(modelCommID, 'read', 'noblock')
                SyncMsg(modelCommID);
            end
            UpdateDisplayMsg(modelCommID, deckParam, deckColors, 'IGT', 'false', {deckPos, 'red'});
            WaitProcDisplay(modelCommID);
        else
            if(~isempty(pnet(modelCommID, 'read', 'noblock', 'view')))
                pnet(modelCommID, 'read', 'noblock')
                SyncMsg(modelCommID);
            end
            UpdateDisplayMsg(modelCommID, deckParam, deckColors, 'IGT', 'false', {deckPos, 'black'});
            WaitProcDisplay(modelCommID);
        end
    end
    %Instead of waiting here, we send a command for ACT-R to schedule an
    %event (relative) to advance the model 4s (see if there is a way to
    %advance meta-process) 
    if( exist('modelCommID', 'var') && ~isempty(modelCommID) && modelCommID ~= -1)
        modelMsg = [];
        WaitJSON(modelCommID, '', startTime, 4);
        if(~isempty(pnet(modelCommID, 'read', 'noblock', 'view')))
            pnet(modelCommID, 'read', 'noblock')
            SyncMsg(modelCommID);
        end
        %Change selected deck back to original color
        UpdateDisplayMsg(modelCommID, deckParam, deckColors, 'IGT', 'false', {deckPos, 'blue'});
        %MarkSelectedDeckDisplayMsg(modelCommID, deckPos, deckVal, 'blue', 'IGT');
        WaitProcDisplay(modelCommID);
        disp('Deck Marked');
    else
        WaitSecs(dPLength);
    end
    %disp('Out MarkSelectedDeck')
end