
function PracticeRun(wPtr, decks)
    screenSize = Screen('Resolution', wPtr);
    
    count = 0;
    while( count < 8 )
        if( mod(count, 4) == 0 )
            if( mod(floor(count/4), 2)  )
                isRed = 1;
            else
                isRed = 0;
            end
            targetDeck = 'A';
        elseif( mod(count, 4) == 1 )
            if( mod(floor(count/4), 2) )
                isRed = 0;
            else
                isRed = 1;
            end
            targetDeck = 'B';
        elseif( mod(count, 4) == 2 )
            if( mod(floor(count/4), 2) )
                isRed = 1;
            else
                isRed = 0;
            end
            targetDeck = 'C';
        else
            if( mod(floor(count/4), 2) )
                isRed = 0;
            else
                isRed = 1;
            end
            targetDeck = 'D';
        end
        Screen('Flip', wPtr);
		ShowRewardBarPract(wPtr);
        [deckParam deckAColor deckBColor deckCColor deckDColor] = ShowDecks(wPtr, decks, imageDir);
        stimBoxParam = ShowStimBox(wPtr, deckParam, imageDir);
        GetRespPract(wPtr, targetDeck);
        ShowMsgPract(wPtr, stimBoxParam, imageDir, targetDeck, isRed);
        count = count+1;
        Screen('Flip', wPtr);
    end
end


function ShowRewardBarPract(wPtr)
    screenSize = Screen('Resolution', wPtr);
    rewX = 150;
    rewY = 50;
    scale = 1/(6750/(screenSize.width-300));
    widthReward = (2000*scale);
    rewMax = (screenSize.width-300);
    height = 25;

    reward_box = [rewX, rewY, rewX + widthReward, rewY + height];
    reward_box_max = [rewX, rewY, rewX + rewMax, rewY + height];
    white = WhiteIndex(wPtr); % pixel value for white
    black = BlackIndex(wPtr); % pixel value for black
    gray = (white + black) / 2;
    color = [0, 250, 0];
    Screen('FillRect', wPtr, gray, reward_box_max');
    Screen('FillRect', wPtr, color', reward_box');

    borrowX = 150;
    borrowY = 80;
    widthBorrow = 2000 * scale;
    borrowBox = [borrowX, borrowY, borrowX + widthBorrow, borrowY + height];
    color = [200, 0, 0];
    
    Screen('FillRect', wPtr, color', borrowBox');
    Screen('TextStyle', wPtr, 0);
    Screen('TextSize', wPtr, 12);
    %Screen('DrawText', wPtr, num2str(count), 10, 10, [0 0 0]);
    Screen(wPtr, 'Flip', [], 1);
end

function GetRespPract(wPtr, targetDeck)
    screenSize = Screen('Resolution', wPtr);
    Screen('TextFont', wPtr, char('Helvetica'));
	Screen('TextSize', wPtr, 24);
    Screen('DrawText', wPtr, strcat('Please select deck-', targetDeck), ...
        (screenSize.width/2) - 150, (screenSize.height/2)+60, [0 0 0]);
    
    Screen('Flip', wPtr, [], 1);
    KbQueueCreate();
    KbQueueStart();
    while(1)
        %[ keyIsDown seconds keyCode ] = KbCheck;
	[ keyIsDown fP fR lP lR ] = KbQueueCheck();
        
        if( isempty(KbName(fP)) || length(find(fP)) ~= 1)
            continue;
        end
      
        if( keyIsDown )
         if( strcmpi(targetDeck, 'a') )
            if( strcmpi(KbName(fP), 'a') || strcmpi(KbName(fP),'1!') || strcmpi(KbName(fP), '1')  )
                break;
            end
         elseif( strcmpi(targetDeck, 'b') )
             if( strcmpi(KbName(fP), 'b') || strcmpi(KbName(fP), '2@') || strcmpi(KbName(fP), '2') )
                break;
             end
         elseif( strcmpi(targetDeck, 'c') )
             if( strcmpi(KbName(fP), 'c') || strcmpi(KbName(fP), '3#') || strcmpi(KbName(fP), '3') )
                 break;
             end
         else
             if( strcmpi(KbName(fP), 'd') || strcmpi(KbName(fP), '4$') || strcmpi(KbName(fP), '4') )
                 break;
             end
         end
        end
    end
    KbQueueStop();
    KbQueueFlush();
end

function MarkSelectedDeckPract(wPtr, targetDeck, isRed)
    screenSize = Screen('Resolution', wPtr);

    wSpace = screenSize.width / 1.8;
    hSpace = screenSize.height;
    posX = wSpace / 5;
    posY = (hSpace / 2) - 245;
    cardWidth = 200;
    cardHeight = 278;

    deckA = [posX, posY, posX + cardWidth, posY + cardHeight];
    deckB = deckA + [posX + cardWidth, 0, posX + cardWidth, 0];
    deckC = deckB + [posX + cardWidth, 0, posX + cardWidth, 0];
    deckD = deckC + [posX + cardWidth, 0, posX + cardWidth, 0];

    if( strcmpi(targetDeck, 'a') )
        deckPos = deckA;
    elseif( strcmpi(targetDeck, 'b') )
        deckPos = deckB;
    elseif( strcmpi(targetDeck, 'c') )
        deckPos = deckC;
    elseif( strcmpi(targetDeck, 'd') )
        deckPos = deckD;
    end
    
    if( ~isRed )
        img = imread(fullfile(imageDir, 'blackBack.jpeg', 'JPG'));
    else
        img = imread(fullfile(imageDir, 'redBack.jpeg', 'JPG'));
    end


    texture = Screen('MakeTexture', wPtr, double(img));
    Screen('DrawTextures', wPtr, texture, [], deckPos');
    Screen('Flip', wPtr, [], 1);
    tic
    while toc < 3, end;
end

function ShowMsgPract(wPtr, stimBoxParam, imageDir, targetDeck, isRed, myPort)
   MarkSelectedDeckPract(wPtr, targetDeck, isRed);
   white = WhiteIndex(wPtr);
   black = WhiteIndex(wPtr);
   gray = (white + black)/2;
   
   textX = stimBoxParam(1) + ((stimBoxParam(3)-stimBoxParam(1))*0.25);
   textY = stimBoxParam(2) + ((stimBoxParam(4)-stimBoxParam(2))*0.5) - (80*0.5);
   [wonImg map wonAlpha] = imread(fullfile(imageDir, 'Won10.png'), 'PNG');
   wonImg(:,:,2) = abs(255-wonImg(:,:,2));
   wonTex = Screen('MakeTexture', wPtr, double(wonImg));
   
   stimBox = imread(fullfile(imageDir, 'iapsBG2.jpg', 'jpg'));
   stimBox = rgb2gray(stimBox);
   stimBoxTex = Screen('MakeTexture', wPtr, double(stimBox));
   Screen('FillRect', wPtr, [gray gray gray], stimBoxParam');
   Screen('Flip', wPtr, [], 1); 
   tic;
   while toc < 0.016, end;
   Screen('DrawTextures', wPtr, stimBoxTex, [], stimBoxParam');
   Screen('DrawTextures', wPtr, wonTex, [], [textX textY-94 textX+250, textY+94]);
   Screen('Flip', wPtr, [], 1);
   tic;
   while toc < 3, end;
end

