%This file needs the ledalab analysis software installed to function
%correctly
function ProcessEDA(wildCard, dirName, numBlocks, wildCard2, dirName2, analysis)

bothSteps = 1;
extractEDA = 1;
analyzeEDA = 1;

if(exist('analysis', 'var') && isnum(analysis))
    if( analysis == 1 )
        analyzeEDA = 0;
        bothSteps = 0;
    elseif( analysis == 2 )
        extractEDA = 0;
        bothSteps = 0;
    end
end
pattern = fullfile(dirName, wildCard);
files = dir(pattern);
retVal = {};
behData = cell(length(files), 3);

if( bothSteps || extractEDA )
 for i=1:length(files)
    fileID = fopen(fullfile(dirName, files(i).name));
    files(i).name
    
    if(streq(files(i).name(1:2), 'm'))
        sex = 1;
    else
        sex = 2;
    end
    headerLine = fgetl(fileID);
    headerLine = strread(headerLine, '%s');
    data = textscan(fileID, '%d\t%f\t%f\t%d\t%d\t%d\t%d\t%d\n');
    dSel = data{4};
    behData{i,1} = str2double(files(i).name(5:end-4));
    behData{i,2} = headerLine(2:7);
    behData{i,3} = [data{3} data{4} data{5} data{7} (data{6}-data{8}) data{2}];
    dRespTime = data{3};

    for j=1:numBlocks
        tempSel = dSel(1+((j-1)*100/numBlocks):j*100/numBlocks);
        tempResp = dRespTime(1+((j-1)*100/numBlocks):j*100/numBlocks);
        d1 = tempSel == 1;
        d2 = tempSel == 2;
        d3 = tempSel == 3;
        d4 = tempSel == 4;
        retVal = [retVal; {str2double(files(i).name(5:end-4)) str2double(files(i).name(3)) ...
            sex mean(tempResp(d1)) mean(tempResp(d2)) mean(tempResp(d3)) mean(tempResp(d4)) numel(tempSel(d1)) ...
            numel(tempSel(d2)) numel(tempSel(d3)) numel(tempSel(d4))}];
    end
    fclose(fileID);
 end
 
 %%Process EDA Data
 pattern = fullfile(dirName2, wildCard2);
 
 files = dir(pattern);
 
 for i=1:length(files);
     fileID = fopen(fullfile(dirName2, files(i).name));
     files(i).name
     edaData = textscan(fileID, '%f:%f:%f,%f,%f,%f,%f,%f,%f,%f', 'HeaderLines', 8);
     edaMat = zeros(length(edaData), 2);
     edaMat(:, 1) = -1;
     hours = edaData{1};
     mins = edaData{2};
     secs = edaData{3};
     for j=1:length(behData)
         if( str2double(files(i).name(5:end-4)) == behData{j,1} )
             trialNum = 1;
             foundBegGame = 0;
             currEvent = -2;
             timeTotal = 0;
             begInd = -1;
             
             for k=1:length(edaData{9})
                 if(trialNum > 100)
                     break;
                 end
                 if( foundBegGame || str2double(behData{j,2}(4)) < hours(k) || ...
                         (str2double(behData{j,2}(4)) == hours(k) && ...
                         (str2double(behData{j,2}(5)) == mins(k) && str2double(behData{j,2}(6)) < secs(k) || ...
                         str2double(behData{j,2}(5)) < mins(k))) )
                     if( foundBegGame == 0 )
                         foundBegGame = 1;
                         begInd = k;
                         
                         display(files(i).name);
                         display([hours(k) mins(k) secs(k)]);
                     end
                     
                     edaMat(k,1) = edaData{9}(k);
                     
                     if( currEvent == -2 )
                         if( behData{j,3}(trialNum,2) < 3 )
                             currEvent = 1;
                             edaMat(k,2) = 1;
                         else
                             currEvent = 4;
                             edaMat(k,2) = 4;
                         end
                     end
                     
                     currEDATime = ((k - begInd)*0.03125);
                     if( currEDATime > (behData{j,3}(trialNum,1) + 8 + timeTotal) && (currEvent ~= 1 && currEvent ~= 4) )
                         if( trialNum < 100 && mod(trialNum+1,20) == 0 )
                             currEvent = -1;
                             timeTotal = behData{j,3}(trialNum,1) + 8 + (behData{j,3}(trialNum+1,6) - (behData{j,3}(trialNum,6) + 8 + behData{j,3}(trialNum+1,1))) + timeTotal;
                             trialNum = trialNum + 1;
                         elseif( trialNum == 100 )
                             trialNum = trialNum + 1;
                         else
                             if( trialNum < 100 && behData{j,3}(trialNum+1,2) <= 2 )
                                 currEvent = 1;
                                 edaMat(k,2) = 1;
                             else
                                 currEvent = 4;
                                 edaMat(k,2) = 4;
                             end
                             timeTotal = behData{j,3}(trialNum,1) + 11.5 + timeTotal;
                             trialNum = trialNum + 1;
                         end
                     elseif( currEDATime > (behData{j,3}(trialNum,1) + 4 + timeTotal) )
                         if( currEvent ~= 3 && currEvent ~= 6 )
                             if( behData{j,3}(trialNum,2) <= 2 )
                                 currEvent = 3;
                                 edaMat(k,2) = 3;
                             else
                                 currEvent = 6;
                                 edaMat(k,2) = 6;
                             end
                         end
                     elseif( currEDATime >= (behData{j,3}(trialNum,1) + timeTotal) )
                         if( currEvent ~= 2 && currEvent ~= 5 )
                             if( behData{j,3}(trialNum,2) <= 2 )
                                if( currEvent == -1 )
                                    edaMat(k-140,2) = 1;
                                end
                                currEvent = 2;
                                edaMat(k,2) = 2;
                             else
                                 if( currEvent == -1 )
                                    edaMat(k-140,2) = 4;
                                 end
                                 currEvent = 5;
                                 edaMat(k,2) = 5;
                             end
                         end
                     end                     
                 end
             end
             edaMat(1:begInd-1,:) = [];
             fileName = strcat('C:\Users\Christopher\Dropbox\Grad\Experiments\Behavioral\Software\Matlab_Psychotoolbox\IGT_Psychotoolbox\subjs\EDA_Proc4\', files(i).name(5:end-4), '.txt');
             dlmwrite(fileName, edaMat, '\t');
         end
     end
 end
end

if( bothSteps || analyzeEDA )
 dataDir = 'C:\Users\Christopher\Dropbox\Grad\Experiments\Behavioral\Software\Matlab_Psychotoolbox\IGT_Psychotoolbox\subjs\EDA_Proc4';
 Ledalab(dataDir, 'open', 'text2', 'filter', 1, 'downsample', 2, 'analyze', 'CDA', 'export_era', [0 4 0.05 1], 1);
 
 pattern = fullfile(dataDir, '*_era.mat');
 files = dir(pattern);
 fileName = 'C:\Users\Christopher\Dropbox\Grad\Experiments\Behavioral\Software\Matlab_Psychotoolbox\IGT_Psychotoolbox\subjs\EDA_Proc4\ProcessedEDA.csv';
 edaFileID = fopen(fileName, 'w');
 fclose(edaFileID);
 for i=1:length(files)
     data = load(files(i).name);
     edaCDA = data.results.CDA;
     edaGlobal = data.results.Global;
     edaTTP = data.results.TTP;
     normalEvents = data.results.Event.nid == -1;
     edaCDA.SCR(normalEvents) = [];
     edaCDA.nSCR(normalEvents) = [];
     edaCDA.Latency(normalEvents) = [];
     edaCDA.AmpSum(normalEvents) = [];
     edaTTP.nSCR(normalEvents) = [];
     edaTTP.Latency(normalEvents) = [];
     edaTTP.AmpSum(normalEvents) = [];
     edaGlobal.Mean(normalEvents) = [];
     data.results.Event.nid(normalEvents) = [];
     fileNames = repmat(str2double(files(i).name(1:end-8)), length(data.results.CDA.SCR), 1);
     edaCDA.SCR = rot90(rot90(rot90(edaCDA.SCR)));
     edaCDA.nSCR = rot90(rot90(rot90(edaCDA.nSCR)));
     edaCDA.Latency = rot90(rot90(rot90(edaCDA.Latency)));
     edaCDA.AmpSum = rot90(rot90(rot90(edaCDA.AmpSum)));
     edaTTP.nSCR = rot90(rot90(rot90(edaTTP.nSCR)));
     edaTTP.Latency = rot90(rot90(rot90(edaTTP.Latency))); ...
     edaTTP.AmpSum = rot90(rot90(rot90(edaTTP.AmpSum)));
     edaGlobal.Mean = rot90(rot90(rot90(edaGlobal.Mean)));
     %File Name, event, CDA-SCR, CDA-nSCR, CDA-Lat, CDA-AmpSum, TTP-nSCR, TTP-Lat,
     %TTP-AmpSum, %GlobalMean
     dlmwrite(fileName, [fileNames, rot90(rot90(rot90(data.results.Event.nid))), edaCDA.SCR, edaCDA.nSCR, ...
         edaCDA.Latency, edaCDA.AmpSum, edaTTP.nSCR, edaTTP.Latency, ...
         edaTTP.AmpSum, edaGlobal.Mean], '-append');
 end
end
end

