function [deckLocSize, deckColors, textures] = ShowDecks(wPtr, decks, imageDir, modelCommID, maxCards)
    %disp('In ShowDecks');
    screenSize = Screen('Resolution', wPtr);
    
    if( ~exist('maxCards','var') || isempty(maxCards) )
        maxCards = 40;
    end
    
    if( exist('modelCommID', 'var') && ~isempty(modelCommID) && modelCommID ~= -1)
        wSpace = (1680 / 1.2); % width space
        hSpace = 1050;
    else
        wSpace = (screenSize.width / 1.2);
        hSpace = screenSize.height;
    end
    deckSize = size(decks.index, 2);
    posX = (screenSize.width - wSpace)/2;
    posY = ((hSpace / 2) - 245);
    cardWidth = 200;
    cardHeight = 278;
    
    xShift = (wSpace - deckSize*200)/(deckSize - 1);
    
    deckLocSize = [posX posY cardWidth cardHeight];
    
    imgs = cell(1, size(decks.index, 2));
    deckColors = cell(1, size(decks.index, 2));
    textures = cell(1, size(decks.index, 2));
    deckParam = [posX, posY, posX + cardWidth, posY + cardHeight];
    
    for i = 1:deckSize
        imgs{i} = imread(fullfile(imageDir, strcat(num2str(i), '.jpeg')), 'JPG');
        if( decks.index(1,i) > maxCards )
            imgs{i} = imread(fullfile(imageDir, 'exhaustedDeck.jpeg'), 'JPG');
            deckColors{i} = 'white';
        else
            deckColors{i} = 'blue';
        end 
        textures{i} = Screen('MakeTexture', wPtr, double(imgs{i}));
        Screen('DrawTextures', wPtr, textures{i}, [], deckParam');
        deckParam = deckParam + [xShift + cardWidth, 0, xShift + cardWidth, 0];
    end
end