% show bars for accumulated rewards and accumulated punishments
function ShowRewardBar(wPtr, rewAcc, punAcc, count)
    screenSize = Screen('Resolution', wPtr);
    rewX = 150;
    rewY = 50;
    if(exist('modelCommID', 'var') && ~isempty(modelCommID) && modelCommID ~= -1)
        scale = 1/(4750/(1680-300));
        widthReward = ((rewAcc-punAcc)*scale) + (2000*scale);
        rewMax = (1680-300);
    else
        scale = 1/(4750/(screenSize.width-300));
        widthReward = ((rewAcc-punAcc)*scale) + (2000*scale);
        rewMax = (screenSize.width-300);
    end
    if( widthReward < 0 )
        widthReward = 0;
    end
    height = 25;

    reward_box = [rewX, rewY, rewX + widthReward, rewY + height];
    reward_box_max = [rewX, rewY, rewX + rewMax, rewY + height];
    white = WhiteIndex(wPtr); % pixel value for white
    black = BlackIndex(wPtr); % pixel value for black
    gray = (white + black) / 2;
    color = [0, 250, 0];
    Screen('FillRect', wPtr, gray, reward_box_max');
    Screen('FillRect', wPtr, color', reward_box');

    borrowX = 150;
    borrowY = 80;
    widthBorrow = 2000 * scale;
    borrowBox = [borrowX, borrowY, borrowX + widthBorrow, borrowY + height];
    color = [200, 0, 0];
    
    Screen('FillRect', wPtr, color', borrowBox');
    Screen('TextStyle', wPtr, 0);
    Screen('TextSize', wPtr, 12);
    
    %Not used now, but could be used to show user how many deck selections
    %they've made
    %Screen('DrawText', wPtr, num2str(count), 10, 10, [0 0 0]);
    Screen(wPtr, 'Flip', [], 1);
end