%%JSON Message Function
function UpdateDisplayMsg(modelCommID, deckParam, deckColors, modelName, ...
            clearDisplay, markDeck, stimBox, rewLoss, nextTrial)

        visLocEndStr = '';
        visObjEndStr = '';
        stimBoxLocStr = [];
        stimBoxObjStr = [];
        rewLocStr = [];
        rewObjStr = [];
        lossLocStr = [];
        lossObjStr = [];
        nextTrialLocStr = [];
        nextTrialObjStr = [];

        if(exist('markDeck', 'var') && ~isempty(markDeck) )
            for i = 1:size(deckColors, 2)
                if( markDeck{1} <= (deckParam(1) + (deckParam(3)*i)) )
                    deckColors(i) = cellstr(markDeck{2});
                end
            end
        end

        if(exist('nextTrial', 'var') && ~isempty(nextTrial) )
            nextTrialLocStr = strcat('{"isa": "visual-location", "slots": {',...
                      '"screen-x": 10, "screen-y": 10, "color": "black", ',...
                      '"kind": "text", "value": "start trial"}},');
            nextTrialObjStr = strcat(visObjEndStr ,'{"isa": "text", "slots": {', ...
                      '"value": "start trial", "width": 10, "height": 10, "color": "black"}},');
        end

        if(exist('stimBox', 'var') && ~isempty(stimBox) && ~isempty(stimBox{2}))
            stimBoxParam = stimBox{1};
            stimBoxVal = stimBox{2};
            stimBoxLocStr = strcat('{"isa": "visual-location", "slots": {',...
                      '"screen-x": ', num2str(stimBoxParam(1)),...
                      ', "screen-y": ', num2str(stimBoxParam(2)), ...
                      ', "color": "grey", "kind": "', stimBoxVal, '"}},');
            stimBoxObjStr = strcat(visObjEndStr ,'{"isa": "picture", "slots": {', ...
                      '"value": "', stimBoxVal, '", "width": ', ...
                      num2str(stimBoxParam(3)), ', "height": ', num2str(stimBoxParam(4)), ...
                      ', "color": "grey"}},');
        end

        if( exist('rewLoss', 'var') && ~isempty(rewLoss) )

            rewParam = rewLoss{1};
            rewVal = rewLoss{2};
            lossParam = rewLoss{3};
            lossVal = rewLoss{4};

            rewLocStr = strcat('{"isa": "visual-location", "slots": {', ...
                      '"screen-x": ', num2str(rewParam(1)), ...
                      ', "screen-y": ', num2str(rewParam(2)), ...
                      ', "color": "black", "kind": "text"}},');
            rewObjStr = strcat('{"isa": "text", "slots": {', ...
                      '"value": ', rewVal, ', "width": ', ...
                      num2str(rewParam(3)), ', "height": ', num2str(rewParam(4)), ...
                      ', "color": "black"}},');

            if(~isempty(lossParam))
              lossLocStr = strcat('{"isa": "visual-location", "slots": {', ...
                  '"screen-x": ', num2str(lossParam(1)), ...
                  ', "screen-y": ', num2str(lossParam(2)), ...
                  ', "color": "black", "kind": "text"}},');
              lossObjStr = strcat('{"isa": "text", "slots": {', ...
                  '"value": ', lossVal, ', "width": ', ...
                  num2str(lossParam(3)), ', "height": ', num2str(lossParam(4)), ...
                  ', "color": "black"}},');
            end
        end

        %eventually, make it so we don't clear the visicon (display)
        %everytime, only when we need to

        updateDisplayBeginStr = strcat('{"model": "', modelName, '",',...
        '"method":', '"update-display", "params": {');
        visLocBeginStr = '"visual-location-chunks": [';
        visLocDeckA = strcat('{"isa": "visual-location", "slots": {',...
                      '"screen-x": ', num2str(deckParam(1)),...
                      ', "screen-y": ', num2str(deckParam(2)), ...
                      ', "color": "', deckColors(1), '"}},');

        visLocDeckB = strcat('{"isa": "visual-location", "slots": {',...
                      '"screen-x": ', num2str((deckParam(1)*2) + deckParam(3)),...
                      ', "screen-y": ', num2str(deckParam(2)), ...
                      ', "color": "', deckColors(2), '"}},');

        visLocDeckC = strcat('{"isa": "visual-location", "slots": {',...
                      '"screen-x": ', num2str((deckParam(1)*3) + deckParam(3)*2),...
                      ', "screen-y": ', num2str(deckParam(2)), ...
                      ', "color": "', deckColors(3), '"}},');

        visLocDeckD = strcat('{"isa": "visual-location", "slots": {',...
                      '"screen-x": ', num2str((deckParam(1)*4) + deckParam(3)*3),...
                      ', "screen-y": ', num2str(deckParam(2)), ...
                      ', "color": "', deckColors(4), '"}}');

        visLocEndStr = strcat(visLocEndStr, '],');
        visObjBeginStr = '"visual-object-chunks": [';
        visObjDeckA = strcat('{"isa": "deck", "slots": {', ...
                      '"value": "A", "width": ', num2str(deckParam(3)), ...
                      ', "height": ', num2str(deckParam(4)), ...
                      ', "color": "', deckColors(1), '"}},');
        visObjDeckB = strcat('{"isa": "deck", "slots": {', ...
                      '"value": "B", "width": ', num2str(deckParam(3)), ...
                      ', "height": ', num2str(deckParam(4)), ...
                      ', "color": "', deckColors(2), '"}},');
        visObjDeckC = strcat('{"isa": "deck", "slots": {', ...
                      '"value": "C", "width": ', num2str(deckParam(3)), ...
                      ', "height": ', num2str(deckParam(4)), ...
                      ', "color": "', deckColors(3), '"}},');
        visObjDeckD = strcat('{"isa": "deck", "slots": {', ...
                      '"value": "D", "width": ', num2str(deckParam(3)), ...
                      ', "height": ', num2str(deckParam(4)), ...
                      ', "color": "', deckColors(4), '"}}');
        visObjEndStr = strcat(visObjEndStr, '],');
        updateDisplayEndStr = strcat('"clear": ', clearDisplay,'}}\n');
        pnet(modelCommID, 'write', sprintf(char(strcat(updateDisplayBeginStr,...
                visLocBeginStr, visLocDeckA, visLocDeckB, visLocDeckC,...
                stimBoxLocStr, rewLocStr, lossLocStr, nextTrialLocStr, visLocDeckD, visLocEndStr,...
                visObjBeginStr, visObjDeckA, visObjDeckB,...
                visObjDeckC, stimBoxObjStr, rewObjStr, lossObjStr, nextTrialObjStr, visObjDeckD, ...
                visObjEndStr, updateDisplayEndStr))));
end